Level01 = Core.class(Sprite)

function Level01:init()
	-- the bg
	application:setBackgroundColor(0x0000a0)

	-- the plugin
	require "liquidfun"
	--b2.setScale(32) -- gideros default: 30px = 1m

	-- the liquidfun world
	self.world = b2.World.new(0, 24, true) -- heavy gravity!

	-- the layers so we can put mobile control over it
	self.gamelayer = Sprite.new()
	self.ui = Sprite.new()

	-- liquidfun debug
	local debugdraw = b2.DebugDraw.new()
	self.world:setDebugDraw(debugdraw)
--	self.gamelayer:addChild(debugdraw)

	-- the level
	self.gamelayer:addChild(Level01_Shape.new(self.world))

	-- some props
	local tex, bmp
	tex = Texture.new("gfx/bg/30.png")
	bmp = Bitmap.new(tex)
	bmp:setPosition(8.5 * 32, 2.4 * 32)
	self.gamelayer:addChild(bmp)
	tex = Texture.new("gfx/bg/35.png")
	bmp = Bitmap.new(tex)
	bmp:setPosition(12 * 32, 8.5 * 32)
	self.gamelayer:addChild(bmp)
	for i = 1, 5 do
		tex = Texture.new("gfx/bg/box.png")
		bmp = Bitmap.new(tex)
		bmp:setPosition(14 * 32 + (i - 1) * 32, 8.85 * 32)
		self.gamelayer:addChild(bmp)
	end
	for i = 1, 5 do
		tex = Texture.new("gfx/bg/box.png")
		bmp = Bitmap.new(tex)
		bmp:setPosition(60 * 32 + (i - 1) * 30, 4.85 * 32)
		self.gamelayer:addChild(bmp)
	end
	for i = 1, 3 do
		tex = Texture.new("gfx/bg/box.png")
		bmp = Bitmap.new(tex)
		bmp:setPosition(80 * 32 + (i - 1) * 24, 8.85 * 32)
		self.gamelayer:addChild(bmp)
	end
	for i = 1, 3 do
		tex = Texture.new("gfx/bg/35.png")
		bmp = Bitmap.new(tex)
		bmp:setPosition(83 * 32 + (i - 1) * 24, 8.5 * 32)
		self.gamelayer:addChild(bmp)
	end

	-- some enemies
	for i = 1, math.random(2, 5) do
		self.enemy = LF_Dynamic_Contour.new(self.world, "gfx/nmes/ghost.png", 1, 1, 1.1, 0, true, 1, 1, 0, 200)
		self.enemy.body:setPosition(math.random(10 * 32, 128 * 32), math.random(2 * 32, 3 * 32)) -- position the body, the bitmap will follow in enterframe
		self.gamelayer:addChild(self.enemy)
	end
	for i = 1, 10 do
		self.enemy02 = LF_Dynamic_Contour.new(self.world, "gfx/nmes/ghost.png", 0.5, 0.5, 1.2, 0, true, 1, 1, 0, 201)
		self.enemy02.body:setPosition(math.random(20 * 32, 128 * 32), 2 * 32) -- position the body, the bitmap will follow in enterframe
		self.gamelayer:addChild(self.enemy02)
	end

	-- some platforms
	local posx, posy = 0, 0
	posx, posy = 110 * 32, 6 * 32
	local mpf01 = LF_Kinematic_Box.new(self.world, "gfx/platforms/mytile32a.png", 10, 1, true,
			10, 0, 1,
			0, 1, posx, posy, -- move vertically
			posx, posy - 2 * 32, posx, posy + 2 * 32,
			11) -- solid platform
	self.gamelayer:addChild(mpf01)
	posx, posy = 123 * 32, 5 * 32
	local mpf02 = LF_Kinematic_Box.new(self.world, "gfx/platforms/mytile32a.png", 5, 1, true,
			10, 0, 1,
			1, 0, posx, posy, -- move horizontally
			posx - 4 * 32, posy, posx + 2 * 32, posy,
			11) -- solid platform
	self.gamelayer:addChild(mpf02)
	posx, posy = 43 * 32, 3 * 32
	local mpf03 = LF_Kinematic_Box.new(self.world, "gfx/platforms/mytile32b.png", 6, 1, true,
			10, 0, 1,
			0, 0, posx, posy,
			posx - 2 * 32, posy, posx + 2 * 32, posy,
			10) -- pass through platform
	self.gamelayer:addChild(mpf03)

	-- a bridge
	tex = Texture.new("gfx/bg/30.png")
	bmp = Bitmap.new(tex)
	bmp:setPosition(88.5 * 32, 2.4 * 32)
	self.gamelayer:addChild(bmp)
	bmp = Bitmap.new(tex)
	bmp:setPosition(104 * 32, 2.4 * 32)
	bmp:setScale(-1, 1)
	self.gamelayer:addChild(bmp)
	local bridge = Bridge.new(self.world, 90 * 32, 3 * 32)
	self.gamelayer:addChild(bridge)
	for i = 1, 3 do
		tex = Texture.new("gfx/bg/30.png")
		bmp = Bitmap.new(tex)
		bmp:setScale(0.5)
		bmp:setPosition(91 * 32 + (i - 1) * 72, 5.9 * 32)
		self.gamelayer:addChild(bmp)
	end

	-- some coins
	self.coins = {}
	posx, posy = 12 * 32, 6 * 32
	for i = 1, 5 do
		local coin = Collectibles.new(self.world, "gfx/collectibles/item.png", 0.5, 0.5, false,
			0, 0, 1,
			0, 0, posx + (i - 1) * 80, posy,
			posx + (i - 1) * 32, posy, posx + (i - 1) * 32, posy,
			50)
		self.coins[i] = coin
		self.gamelayer:addChild(coin)
	end
	posx, posy = 28 * 32, 7.5 * 32
	for i = 1, 5 do
		local coin = Collectibles.new(self.world, "gfx/collectibles/item.png",   0.5, 0.5, false,
			0, 0, 1,
			0, 0, posx + (i - 1) * 64, posy - (i - 1) * 22,
			posx + (i - 1) * 32, posy, posx + (i - 1) * 32, posy,
			50)
		self.coins[i] = coin
		self.gamelayer:addChild(coin)
	end
	posx, posy = 40.5 * 32, 1.25 * 32
	for i = 1, 5 do
		local coin = Collectibles.new(self.world, "gfx/collectibles/item.png",   0.5, 0.5, false,
			0, 0, 1,
			0, 0, posx + (i - 1) * 40, posy,
			posx + (i - 1) * 32, posy, posx + (i - 1) * 32, posy,
			50)
		self.coins[i] = coin
		self.gamelayer:addChild(coin)
	end

	-- the player
	self.player = Player.new(self.world, "gfx/player/HQ_Trooper_all.png", 6, 13)
	self.player.body:setPosition(40 * 32, 2 * 32) -- position the body, the bitmap will follow in enterframe
	self.gamelayer:addChild(self.player)

	-- ui
	self.score = TextField.new(nil, "COINS: 00")
	self.score:setScale(2)
	self.score:setPosition(2, 2 * 8)
	self.score:setTextColor(0xff00ff)
	self.ui:addChild(self.score)
	self.nrg = TextField.new(nil, "NRG: 03")
	self.nrg:setScale(2)
	self.nrg:setPosition(2, 4 * 8)
	self.nrg:setTextColor(0xff00ff)
	self.ui:addChild(self.nrg)
	self.lives = TextField.new(nil, "LIVES: 03")
	self.lives:setScale(2)
	self.lives:setPosition(2, 6 * 8)
	self.lives:setTextColor(0xff00ff)
	self.ui:addChild(self.lives)
	
	-- the game
	self:addChild(self.gamelayer)
	self:addChild(self.ui)

	-- listeners
	self:addEventListener("enterBegin", self.onTransitionInBegin, self)
	self:addEventListener("enterEnd", self.onTransitionInEnd, self)
	self:addEventListener("exitBegin", self.onTransitionOutBegin, self)
	self:addEventListener("exitEnd", self.onTransitionOutEnd, self)
end

-- the game loop
function Level01:onEnterFrame(e)
	local playerposx, playerposy = self.player.body:getPosition()
	-- camera follow player
	local offsetX = -(playerposx - contentwidth / 2)
	self.gamelayer:setX(offsetX)
	local offsetY = -(playerposy - contentheight / 2)
	self.gamelayer:setY(offsetY)
	self.world:step(1/60, 1, 1)
	-- score/lives/coins
	self.score:setText("COINS: "..g_score)
	self.nrg:setText("NRG: "..self.player.nrg)
	self.lives:setText("LIVES: "..self.player.lives)
end

-- EVENT LISTENERS
function Level01:onTransitionInBegin()
	self:myKeysPressed()
end

function Level01:onTransitionInEnd()
	self:addEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)
	-- mobile controls
	if application:getDeviceInfo() == "Android" then
		local mymobile = Mobile.new(self.player)
		self:addChild(mymobile)
	end
end

function Level01:onTransitionOutBegin()
	self:removeEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)
end

function Level01:onTransitionOutEnd()
end

-- KEYS HANDLER
function Level01:myKeysPressed()
	self:addEventListener(Event.KEY_DOWN, function(e)
		-- for mobiles and desktops
		if e.keyCode == KeyCode.BACK or e.keyCode == KeyCode.ESC then
--			sceneManager:changeScene("menu", 1, transitions[2], easing.outBack)
		end
	end)
end
